/* 
   - The contents of this file are subject to the Mozilla Public
   - License Version 1.1 (the "License"); you may not use this file
   - except in compliance with the License. You may obtain a copy of
   - the License at http://www.mozilla.org/MPL/
   -
   - Software distributed under the License is distributed on an "AS
   - IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
   - implied. See the License for the specific language governing
   - rights and limitations under the License.
   -
   - The Original Code is this file as it was released on
   - April 1, 2001.
   -
   - The Initial Developer of the Original Code is Henk-Johan van Rantwijk.
   - Portions created by Henk-Johan van Rantwijk are Copyright (C) 2001
   - Henk-Johan van Rantwijk.  All Rights Reserved.
   -
   - Contributor(s):
   -  Henk-Johan van Rantwijk <bugs4hj@netscape.net> (Original Author)
   -  David Perry <d.perry@utoronto.ca>
   -
   - Alternatively, the contents of this file may be used under the
   - terms of the GNU General Public License Version 2 or later (the
   - "GPL"), in which case the provisions of the GPL are applicable
   - instead of those above.  If you wish to allow use of your
   - version of this file only under the terms of the GPL and not to
   - allow others to use your version of this file under the MPL,
   - indicate your decision by deleting the provisions above and
   - replace them with the notice and other provisions required by
   - the GPL.  If you do not delete the provisions above, a recipient
   - may use your version of this file under either the MPL or the
   - GPL.
   -
*/

////////////////////////////////////////////////////////////////////////////////
function defineShortURL(aURI)
{
  try {
    var i = aURI.indexOf(":");
  } 
  catch(ex) {
    return aURI;
  }
  if (i != -1) {
    while(!isAlphaNum(aURI[i]))
      i++;
    return aURI.substring(i, aURI.length);
  }
  return aURI;
}
////////////////////////////////////////////////////////////////////////////////
function isAlphaNum(mixedCase)
{
  var allCaps = mixedCase.toUpperCase();
  for (var i = allCaps.length - 1; i >= 0; i--) {
    var c = allCaps.charAt(i);
    if ((c < 'A' || c > 'Z') && (c < '0' || c > '9') && (c!='_'))
      return false;
  }
  return true;
}
////////////////////////////////////////////////////////////////////////////////
function getLocationFromClipboard()
{
  var url = null;

  try {
    var clipboard = Components.classes["@mozilla.org/widget/clipboard;1"]
                              .getService(Components.interfaces.nsIClipboard);

    var trans = Components.classes["@mozilla.org/widget/transferable;1"]
                          .createInstance(Components.interfaces.nsITransferable);

    trans.addDataFlavor("text/unicode");
    clipboard.getData(trans, clipboard.kGlobalClipboard);

    var data = {};
    var dataLen = {};
    trans.getTransferData("text/unicode", data, dataLen);

    if (data) {
      data = data.value.QueryInterface(Components.interfaces.nsISupportsString);	  
      url = data.data.substring(0, dataLen.value / 2);
    }
    else {
      alert(mzGetTextFromBundle("noClipboardData"));
    }
  } catch (ex) {
    alert(mzGetTextFromBundle("clipboardReadError"));
  }
  return url;
}
////////////////////////////////////////////////////////////////////////////////
function displayVersion()
{
  var mVersion = getBrowser().mVersion;
  var mVersionRev = getBrowser().mVersionRev;

  window.openDialog("chrome://multiviews/content/multiviewsAbout.xul", "multiviewsClose", 
                    "chrome,dialog,dependent",(mVersion+mVersionRev),loadURI);
}
////////////////////////////////////////////////////////////////////////////////
function doCheck4Updates()
{
  var version = getBrowser().mVersion;
  var revision = getBrowser().mVersionRev;
  getBrowser().addTab("http://multizilla.mozdev.org/update.html?version="+version+"&revision="+revision, null);
}
////////////////////////////////////////////////////////////////////////////////
function validateThisPage(aURL)
{
  if (aURL) {
    var IOService = Components.classes["@mozilla.org/network/io-service;1"]
                              .getService(Components.interfaces.nsIIOService);
    if (!IOService)
       return;
    var scheme = "";

    try {
      scheme = IOService.extractScheme(aURL, {schemeStartPos:0}, {schemeEndPos:0});
    } catch(ex) { 
      alert(mzGetTextFromBundle("errorText"));
    }
    if (scheme == "http") {
      var checkURL = "http://validator.w3.org/check?uri=" + aURL + 
                     "&charset=%28detect+automatically%29&doctype=Inline";
      getBrowser().addTab(checkURL, null);
    }
    else { 
      alert("Can't handle used protocol type "+ scheme +":\nThis validator supports http: only");
      // alert(("unsupportedProtocolForValidator", scheme));
    }
  }
}
//////////////////////////////////////////////////////////////////////////
function handlePTFolders(node)
{
  if (!node.hasChildNodes())
    return; // no folder, bail out
  var personalToolbar = node.parentNode;
  // 'hbox' for folders and 'toolbox' for the Bookmarks button 
  if (personalToolbar.nodeName == "hbox")
    personalToolbar = personalToolbar.parentNode;
  if ("lastPopup" in personalToolbar && personalToolbar.lastPopup != null) {
    node = node.firstChild;
    if (node.nodeName == "menupopup") {
      if (personalToolbar.lastPopup != null)
        personalToolbar.lastPopup.hidePopup();
      node.showPopup(node);
    }
  }
}
//////////////////////////////////////////////////////////////////////////
function initViewMenu(aMenupopup)
{
  // XXX: Total HACK to remove the original menu items
  var i = 0;
  initGoogleBoxMenuitem("GoogleBoxShowHideMenuitem");
  var removal = aMenupopup.getElementsByAttribute("observes", "cmd_viewpersonaltoolbar"); 

  if (removal.length) {
    for (i = 0; i < removal.length; i++) {
      if (!removal[i].hasAttribute("acceltext"))
        aMenupopup.removeChild(removal[i]);
    }
  }
  removal = aMenupopup.getElementsByAttribute("observes", "cmd_viewnavbar");
  if (removal.length) {
    for (i = 0; i < removal.length; i++) {
      if (!removal[i].hasAttribute("acceltext"))
        aMenupopup.removeChild(removal[i]);
    }
  }
  initToolbarsMenu();
}
//////////////////////////////////////////////////////////////////////////
// this is a GoogleBox specific function
//////////////////////////////////////////////////////////////////////////
function aboutGooglebox()
{
  var installed = mzToolbox.mToolboxActivated;
  var internalToolBox = document.getElementById("internalToolBox");

  if (!installed)
    gBrowser.selectedTab = gBrowser.addTab("http://multizilla.mozdev.org/features/googlebox.html");
  else
    alert(internalToolBox.mVersionInfo);
}
//////////////////////////////////////////////////////////////////////////
// this is a GoogleBox specific function
//////////////////////////////////////////////////////////////////////////
function initGoogleBoxMenuitem(aMenuitem)
{
  var toolboxEnabled = readMyPref("multizilla.integrated.toolbar", "bool", false);

  if (mzToolbox.mToolboxActivated && toolboxEnabled)
    document.getElementById(aMenuitem).removeAttribute("hidden");
  else
    document.getElementById(aMenuitem).setAttribute("hidden", "true");
}
//////////////////////////////////////////////////////////////////////////
// this is a GoogleBox specific function
//////////////////////////////////////////////////////////////////////////
function toggleOrEnableGoogleBox()
{
  if (!mzToolbox.mToolboxActivated)
    return;

  var enabled = readMyPref("multizilla.integrated.toolbar", "bool", false);

  if (!enabled) {
    var promptService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService(Components.interfaces.nsIPromptService);
    var title = mzGetTextFromBundle("mzWizard");
    var text = mzGetTextFromBundle("enableGoogleBoxText");
    var checkbox = {value:0};
    var result = promptService.confirmEx(window, title, text, 
                                        (promptService.BUTTON_POS_0 * promptService.BUTTON_TITLE_YES) +
                                        (promptService.BUTTON_POS_1 * promptService.BUTTON_TITLE_NO),
                                         null, null, null, null, checkbox);

     if (result == 1)
       return;
     writePref("bool", "multizilla.integrated.toolbar", true);
  }
  goToggleToolbar("internalToolBox", "cmd_viewIntegratedToolBox");
  mzToolbox.refreshMultiZillaButtons();
}
//////////////////////////////////////////////////////////////////////////
// Don't know what I had in mind with this function but we don't use it!
//////////////////////////////////////////////////////////////////////////
function dumpHostnames()
{
  if ("links" in document.commandDispatcher.focusedWindow.document) {
    var links = document.commandDispatcher.focusedWindow.document.links;
    for (var i = 0; i < links.length; i++) {
      dump(links[i].host+' - ');
    }
    dump('\ni = '+i);
 }
}
//////////////////////////////////////////////////////////////////////////
function askToDisableButton(aEvent)
{
  aEvent.preventBubble();

  var button = aEvent.target;
  var buttonId = button.getAttribute("id");

  if (buttonId) {
    var promptService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"]
                                  .getService(Components.interfaces.nsIPromptService);

    if (promptService.confirm(window, mzGetTextFromBundle("disableButtonTitle"), mzGetTextFromBundle("disableButtonText"))) {
      var index = buttonId.indexOf("-");
      var buttonName = buttonId.substring(0, index);
      var observerId = button.getAttribute("observes");

      if (observerId) {
         button.setAttribute("hidden", "true");
         /* var observer = document.getElementById(observerId);
         alert(observer); */
         // observer.setAttribute("disabled", true);
      }
      if (buttonId == "qpmenu-tbbutton" || buttonId == "clearlocbar-tbbutton")
        writePref("bool", "multizilla.showbutton." + buttonName, false);
      else
        writePref("bool", "browser.toolbars.showbutton." + buttonName, false);
    }
  }
}
//////////////////////////////////////////////////////////////////////////
function initButtonContextMenu(aContextMenu, aID)
{
  var buttonIDs = (aID == "NT") ? [ "skip", "skip", "back-button", "forward-button", 
                                    "reload-button", "stop-button", "skip", 
                                    "qpmenu-tbbutton", "clearlocbar-tbbutton", 
                                    "skip", "go-button", "search-button", "print-button" ] : 
                                  [ "skip", "skip", "home-button", "bookmarks-button", 
                                    "qpmenu-button" ];

  for (var i = 0; i < buttonIDs.length; i++) {
    if (buttonIDs[i] != "skip") {
      var button = document.getElementById(buttonIDs[i]);
      var hidden = button.getAttribute("hidden");
      aContextMenu.childNodes[i].setAttribute("checked", (hidden == "true") ? "false" : "true");
    }
  }
  return;
}
//////////////////////////////////////////////////////////////////////////
function doButtonUpdate(aEvent)
{
  var buttonId = aEvent.getAttribute("buttonid");
  var index = buttonId.indexOf("-");
  var buttonName = buttonId.substring(0, index);

  if (buttonId == "qpmenu-tbbutton" || buttonId == "clearlocbar-tbbutton")
    toggleBoolPref("multizilla.showbutton." + buttonName, "bool", true);
  else
    toggleBoolPref("browser.toolbars.showbutton." + buttonName, "bool", true);
}
//////////////////////////////////////////////////////////////////////////
function overrideContextMenu(aEvent)
{
  if (aEvent.button == 2) {
    var contextMenu = aEvent.target.getAttribute("context-menu");
    var overrideContextPopup = document.getElementById("buttonContextPopup");
    var defaultContextPopup = document.getElementById(contextMenu);
    // Note that attribute popup="" is needed in order to open the context menu at the desired position!
    if (aEvent.ctrlKey) {
      if (defaultContextPopup)
        defaultContextPopup.hidePopup();
      overrideContextPopup.showPopup(overrideContextPopup, aEvent.clientX+2, aEvent.clientY+2, "popup", "at_pointer");
    }
    else if (contextMenu) {
      overrideContextPopup.hidePopup();
      defaultContextPopup.showPopup(defaultContextPopup, aEvent.clientX+2, aEvent.clientY+2, "popup", "at_pointer");
    }
  }
}
////////////////////////////////////////////////////////////////////////////////
function viewPermissionManager(aType) {
  if (!aType) {
    var defaultType = readMyPref("multizilla.perm-manager.default-manager", "string", "cookieManager");
    aType = defaultType;
  }
  if (!CycleWindow("multizilla:permissionmanager"))
    window.openDialog("chrome://multiviews/content/multiviewsPermissionManager.xul", "_blank", "chrome,resizable=yes", aType);
}
////////////////////////////////////////////////////////////////////////////////
function openPrivacyManager()
{
  alert("Oops, Alpha software error?\n" +
        "No, I am still working on it.");
}
////////////////////////////////////////////////////////////////////////////////
function onPermissionButtonClick(aEvent)
{
  if (aEvent.ctrlKey)
    mzClearAllCookies();
  else 
    viewPermissionManager("cookieManager");
}
////////////////////////////////////////////////////////////////////////////////
function useFirstPage()
{
 var uriToLoad = null;
  if ("arguments" in window && window.arguments.length >= 1 && window.arguments[0])
    uriToLoad = window.arguments[0];
  if (readMyPref("multizilla.tabs.blank-tab-first", "bool", true)) {
    if ((readMyPref("browser.startup.page", "int", 1) == 1 && 
        getHomePage() == "about:blank" || getHomePage() == "") || uriToLoad == "about:blank" || 
        readMyPref("browser.startup.page", "int", 0) == 3 && uriToLoad == "about:blank")
      return true;
  }
  return false;
}
//////////////////////////////////////////////////////////////////////////
// We need to get notified of blocked popup windows. We replace the 
// original eventlistener for 'DOMPopupBlocked' with our (this) event 
// listener and call 'onPopupBlocked' (original function) when we're done.
//////////////////////////////////////////////////////////////////////////
function mzOnPopupBlocked(aEvent)
{
  var popupWindowURI = aEvent.popupWindowURI;
  var requestingWindowURI = aEvent.requestingWindowURI;
  popupWindowURI = popupWindowURI ? popupWindowURI.spec : null;
  // requestingWindowURI = requestingWindowURI ? requestingWindowURI.spec : null;
  // alert("popupWindowURI: "+popupWindowURI+"\nrequestingWindowURI: "+requestingWindowURI);
  var browser = getBrowserForDocument(aEvent.target);
  // var popupWindowURI = aEvent.popupWindowURI;
  // Keep URI so that we can open it on request!
  if (popupWindowURI) { // Well, if we have one, because that's not always the case!
    // var browser = getBrowserForDocument(aEvent.target);
    addBlockedWindowToMenu(browser, popupWindowURI);
  }
  browser.mNumberOfBlockedWindows++;
  onPopupBlocked(aEvent); // we're done, call mozilla's listener
}
//////////////////////////////////////////////////////////////////////////
// This will add the URL of the blocked popup window to the list and also 
// enables the icon/menu popup on the status bar.
//////////////////////////////////////////////////////////////////////////
function addBlockedWindowToMenu(aBrowser, aBlockedURI)
{
  // Add the URL to the list of blocked windows. This allows the user to open it!
  aBrowser.mBlockedWindows.push(aBlockedURI);
  /***
  * We keep track of the last 15 blocked popup windows only!
  * I'm still not sure *if* we should check for duplicates.
  */
  if (aBrowser.mBlockedWindows.length > 15)
    aBrowser.mBlockedWindows.splice(0, 1);
  // Do we need to enable the blocked window menu icon?
  if (aBrowser == gBrowser.mCurrentBrowser) {
    var button = document.getElementById("blocked-window-button");
    button.setAttribute("blocked", "true");
  }
}
//////////////////////////////////////////////////////////////////////////
// This will add menu items to the blocked window menu on the status bar
//////////////////////////////////////////////////////////////////////////
function buildBlockedPopupWindowMenu(aParent)
{
  deleteHistoryItems(aParent); // depends on sessionHistoryUI.js
  var tabbrowser = getBrowser();
  var counter = tabbrowser.mCurrentBrowser.mBlockedWindows.length;

  for (var i = 0; i < counter; i++) {
    var menuitem = document.createElement("menuitem");
    menuitem.setAttribute("label", tabbrowser.mCurrentBrowser.mBlockedWindows[i]);
    menuitem.setAttribute("index", i); // make deleteHistoryItems() work
    aParent.appendChild(menuitem);
  }
}
//////////////////////////////////////////////////////////////////////////
// This allows you to open the blocked window in a new Tab or new Window
//////////////////////////////////////////////////////////////////////////
function openBlockedWindow(aEvent)
{
  var URL = aEvent.originalTarget.getAttribute("label");
  if (URL == "about:blank" || URL == "")
    return;
  if (aEvent.ctrlKey) {
    var win = window.open(URL);
    // win.sizeToContent();
  }
  else {
    var tabbrowser = getBrowser();
    tabbrowser.selectedTab = tabbrowser.addTab(URL);
  }
}
//////////////////////////////////////////////////////////////////////////
// This updates the number of blocked windows in the tooltip
//////////////////////////////////////////////////////////////////////////
function updateBlockedWindowTooltip()
{
  var blockedWindowButton = document.getElementById("blocked-window-button");
  var tooltipText = mzGetTextFromBundle("blockedWindowButton.tooltip");
  var browser = gBrowser.getBrowserForTab(gBrowser.selectedTab);
  tooltipText = tooltipText.replace(/%S/, browser.mNumberOfBlockedWindows);
  blockedWindowButton.setAttribute("tooltiptext", tooltipText);
}

//////////////////////////////////////////////////////////////////////////
// I wrote this small function in order to fix bug 3681 without a hastle
// Usage: alert(getTabbrowser(this));return;var tabbrowser = ...
//////////////////////////////////////////////////////////////////////////
/* function getTabbrowser(node)
{
  var i = 0;
  while (node.nodeName != "tabbrowser") {
    node = node.parentNode;
    i++;
  }
  alert(i)
  return node;
} */
